// deployer NginxModule implementation
// Copyright (C) 2024 Jean-Cloud
// GNU General Public License v3

#include <filesystem>
#include <fstream>
#include "NginxModule.h"
using namespace std;
namespace fs=filesystem;

//constructor
NginxModule::NginxModule(){
    name="Nginx";
}

//destructor inline

//public methods
int NginxModule::Prepare ()
{
    cout << "nginx preparation" << endl;
    //create proxy_dir
    string proxy_dir=getenv("proxy_dir");
    fs::create_directories(proxy_dir);

    //delete current new_conf directory (to start from scratch)
    string new_nginx_conf_path=getenv("new_nginx_conf_path");
    fs::remove_all(new_nginx_conf_path);

    //create new new_conf directory
    fs::create_directories(new_nginx_conf_path);

    //create new conf file (for tests purposes)
    string nginx_conf_path=getenv("nginx_conf_path");
    //open the old conf file
    ifstream input("./services/_proxy/nginx.conf");
    if (!input) {
        std::cerr << "Error when opening /services/_proxy/nginx.conf" << std::endl;
        return 1;
    } else {
        stringstream buffer;
        buffer << input.rdbuf();
        string content = buffer.str();
        input.close();
        //replace nginx_conf_path with the new nginx_conf_path in the conf
        size_t pos=string::npos;
        while (content.find(nginx_conf_path)!=string::npos){
            content.replace(content.find(nginx_conf_path),nginx_conf_path.length(),new_nginx_conf_path);
        }
        //fill the new conf file
        ofstream output (proxy_dir+"/new_nginx.conf");
        output << content;
        output.close();
    }
    return 0;
}

int NginxModule::Deploy (string serviceUsername)
{
    //write the new conf 
    

    return 0;
}

int NginxModule::Remove(string serviceUsername)
{
    return 0;
}

int NginxModule::Clean ()
{
    cout << "nginx cleaning" << endl;
    return 0;
}